class Terrain extends GameObj {
  boolean atRest = false;
  int id;
  float stweight = 0.5;

  boolean put = false;
  boolean locked = false;
  Terrain parent;
  ArrayList<Terrain> children;

  Terrain(int id) {
    super(new PVector(0, 0), new PVector(15, 15));
    this.id = id;
    generateColor();
    parent = null;
    children = new ArrayList<Terrain>();
  }

  Terrain(int id, PVector pos) {
    super(pos, new PVector(terrainSize, terrainSize));
    this.id = id;
    generateColor();
    parent = null;
    children = new ArrayList<Terrain>();
  }

  void generateColor() {
    this.H = noise(.005*position.x, .005*position.y);
    this.S = 0.8;
    this.B = 0.4;
  }
  void update() {
    super.update();
  }

  void draw() {
    // draw a rect
    //noStroke();
    strokeWeight(stweight);
    fill(H, S, B);
    rect(position.x, position.y, dimensions.x, dimensions.y);
    /*
    strokeWeight(3);
     if(parent != null) line(position.x, position.y, parent.position.x, parent.position.y);
     strokeWeight(1);
     for(int i = 0; i < children.size(); i++){
     line(position.x, position.y, children.get(i).position.x, children.get(i).position.y);
     }*/
  }
  
  void drawShineOnChildren(){
    locked = true;
    drawShine();
    for (int i = 0; i < children.size(); i++) {
      children.get(i).drawShineOnChildren();
    } 
  }
  
  void drawShine(){
    strokeWeight(0);
    fill(H, S-.5, B, 0.3);
    ellipse(position.x, position.y, terrainSize+6, terrainSize+6);
    ellipse(position.x, position.y, terrainSize+3, terrainSize+3);
  }

  void setRest() {
    atRest = true;
    velocity.y = 0;
  }

  int countChildren() {
    int numTotalChildren = children.size();
    for (int i = 0; i < children.size(); i++) {
      numTotalChildren += children.get(i).countChildren();
    }
    return numTotalChildren;
  }
}

