
GameObj[] inventoryBlocks;
int selectedBoxIndex = -1;

void setupInventoryCollision() {
  for (int i = 0; i < player.inventory.length; i++) {
    inventoryBlocks[i] = new GameObj(new PVector(40 + (i*20), 40), new PVector(10, 10));
    inventoryBlocks[i].setColor(((float)i/(float)player.inventory.length), 0.6, 1);
  }
}

int checkInventoryCollision() {
  if (mouseY < 80) {
    for (int i = 0; i < inventoryBlocks.length; i++) {
      float horizontalDistance = abs(mouseX - inventoryBlocks[i].position.x);
      if (horizontalDistance  < (inventoryBlocks[i].dimensions.x/2)) {
        float verticalDistance = abs(mouseY - inventoryBlocks[i].position.y);
        if (verticalDistance  < (inventoryBlocks[i].dimensions.y/2) ) {
          println("Collided with inventory box id " + i);
          return i;
        }
      }
    }
    return -1;
  }
  return selectedBoxIndex;
}

void displayInventoryHUD() {
  // Display a background bit eventually
  fill(.3, .01, .01, 0.5);
  rect(40 +((35*20)/2), 40, 40 + 35*20, 40);

  fill(0, 0, 1);
  text("Inventory", 30, 20);

  for (int i = 0; i < player.inventory.length; i++) {
    // Draw a rectangle representative of the color, spaced out
    //println("Color: " + i + "/" + player.inventory.length + " = " + ((float)i/(float)player.inventory.length));
    //fill(((float)i/(float)player.inventory.length), 0.6, 0.8);
    //rect(40 + (i*20), 40, 10, 10);
    inventoryBlocks[i].draw();
    //stroke(0, 0, 1);
    fill(0, 0, 1);
    text(player.inventory[i].size(), 35 + (i*20), 52);
    // With a text of how many colors are in that group
  }

  displaySelectedColor();
}

void displaySelectedColor() {
  // Display a background bit eventually
  fill(.3, .01, .01, 0.5);
  rect(width-60, 100, 40, 40);

  fill(0, 0, 1);
  text("Selected", width-86, 80);
  
  if(selectedBoxIndex >= 0){
    fill(inventoryBlocks[selectedBoxIndex].H, inventoryBlocks[selectedBoxIndex].S, inventoryBlocks[selectedBoxIndex].B);
    rect(width-60, 95, 20, 20);
    fill(0, 0, 1);
    text(player.inventory[selectedBoxIndex].size(), width-66, 118);
  } else {
    text("None", width-76, 105);
  }
}

